/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2012 Mudit Raj Gupta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Mudit Raj Gupta <mudit.raaj.gupta@gmail.com>
 */

#include "ns3/log.h"
#include "ns3/link-to-rti.h"

#include <string.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <pthread.h>

NS_LOG_COMPONENT_DEFINE ("LinkToRti");

namespace ns3 {

//socket related variables
int i;
pthread_t alt;
socklen_t clilen;
struct sockaddr_in serv_addr, cli_addr;
int rc,sockfd, newsockfd, portno, flag=0, noWork=0,n,count=0;
char buffer[256];

int LinkToRti::RTI_CLK;
int LinkToRti::RTI_STOP=0;
int LinkToRti::RTI_START=0;

//Connection to RTI

void * rtiLink(void* p)
{
 LinkToRti obj;// = new LinkToRti;
  while(!flag)
 {
   count++;
   n=read(newsockfd,buffer,256);
   if(n>0)
   {
     if(strcmp(buffer, "#####")==0)
     {

     obj.timeAdv();

      }

      if(strcmp(buffer, "+++++")==0)
      {
      obj.stopSim();
        flag=1;
      }
      
      else
      {
        NS_LOG_LOGIC("New Message Received");
      }
      
      bzero(buffer,256);
      
     
    }
    if (n < 0) 
      NS_LOG_ERROR("ERROR reading from socket");
  }
  obj.close_sock();        
  return NULL;
}
//ask RTI to advance time

void LinkToRti::reqTimeAdv(void)
{
 // timeAdv();
NS_LOG_UNCOND("Sending Request");
  n = write(newsockfd,"*",1);
  if (n < 0) 
    NS_LOG_UNCOND("ERROR writing to socket");
  NS_LOG_LOGIC("Time Advance Requested\n");
}

//When time advance granted

void LinkToRti::timeAdv(void)
{
  RTI_CLK++;
  NS_LOG_LOGIC("Time Advance Granted");
  NS_LOG_UNCOND("TEST");
}

//To start the simulation

void LinkToRti::startSim(void)
{
  RTI_START=1;
  NS_LOG_LOGIC("Starting Simulation\n");
  rc = pthread_create(&alt, NULL, &rtiLink, NULL);     
  if(rc)	
    NS_LOG_ERROR("Thread: listen creation failed");      
  RTI_CLK=0;
}

//To stop the simulation

void LinkToRti::stopSim(void)
{
 RTI_STOP=1;
  NS_LOG_LOGIC("Stopping simulation\n");
}

//Initialization

void LinkToRti::init_sock(void)
{
  sockfd = socket(AF_INET, SOCK_STREAM, 0);
  if (sockfd < 0) 
    NS_LOG_ERROR("ERROR opening socket");
  bzero((char *) &serv_addr, sizeof(serv_addr));
  portno = PORT_NO;
  serv_addr.sin_family = AF_INET;
  serv_addr.sin_addr.s_addr = INADDR_ANY;
  serv_addr.sin_port = htons(portno);
  if (bind(sockfd, (struct sockaddr *) &serv_addr,
  sizeof(serv_addr)) < 0) 
    NS_LOG_ERROR("ERROR on binding");
  listen(sockfd,5);
  clilen = sizeof(cli_addr);
  newsockfd = accept(sockfd, 
  (struct sockaddr *) &cli_addr, 
                 &clilen);
  if (newsockfd < 0) 
    NS_LOG_ERROR("ERROR on accept");
}

//closing

void LinkToRti::close_sock(void)
{
  close(newsockfd);
  close(sockfd);
}

//Have to be removed


void LinkToRti::connectToRTI(void)
{
//startSim();	

  //init_sock();   
  n=read(newsockfd,buffer,256);
  if(n>0)
  {
    if(strcmp(buffer, "*****")==0)
    startSim();	
  }
}

}// namespace ns3
