#!/bin/bash

USAGE="usage: linux.sh [compile] [clean] [execute [federate-name]]"

################################
# check command line arguments #
################################
if [ $# = 0 ]
then
	echo $USAGE
	exit;
fi

######################
# test for JAVA_HOME #
######################
JAVA=java
if [ "$JAVA_HOME" = "" ]
then
	echo WARNING Your JAVA_HOME environment variable is not set!
	#exit;
else
        JAVA=$JAVA_HOME/bin/java
fi

#####################
# test for RTI_HOME #
#####################
if [ "$RTI_HOME" = "" ]
then
	cd ../../RTI
	RTI_HOME=$PWD
	export RTI_HOME
	cd ../model/ns3Federate
	echo WARNING Your RTI_HOME environment variable is not set, assuming $RTI_HOME
fi

############################################
### (target) clean #########################
############################################

if [ $1 = "clean" ]
then
	echo "deleting ns3Federate jar file and left over logs"
	rm src/*.class
	rm ns3Federate.jar
	rm -Rf logs
	exit;
fi

############################################
### (target) compile #######################
############################################

if [ $1 = "compile" ]
then
	echo "compiling ns3Federate"
	cd src
	javac -cp ./:$RTI_HOME/lib/portico.jar *.java
	jar -cf ../ns3Federate.jar *.class
	cd ../
	exit;
fi

############################################
### (target) execute #######################
############################################

if [ $1 = "execute" ]
then
	shift;
	java -cp ./ns3Federate.jar:$RTI_HOME/lib/portico.jar ns3Federate $*
	exit;
fi

echo $USAGE

